#
# spec file for package mailman (Version 2.1.2)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org
#

# neededforbuild  -sendmail openldap2-client openssl pcre postfix python python-devel python-japanese python-korean
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils cracklib gcc gdbm gettext heimdal-lib libtool pcre pcre-devel perl postfix python python-devel python-japanese python-korean rpm

Name:         mailman
%define DISTRIBUTABLE 1
License:      GPL
Group:        Productivity/Networking/Email/Mailinglists
URL:          http://www.gnu.org/software/mailman/mailman.html
Requires:     python cron smtp_daemon python-korean python-japanese python-xml
Autoreqprov:  on
Prereq:       /usr/sbin/useradd /usr/sbin/groupadd /bin/echo /bin/cp /bin/rm /bin/mkdir /usr/bin/awk /usr/bin/touch /usr/bin/getent openssl
Summary:      The GNU Mailing List manager
Version:      2.1.2
Release:      95
Source:       %{name}-%{version}.tgz
Source1:      README.SuSE
Source2:      apache.tar.bz2
Source3:      sysconfig.apache-mailman
%if %DISTRIBUTABLE
Source4:      SuSEconfig.mailman
%else
Source4:      SuSEconfig.mailman-SuSE
%endif
Source5:      rcmailman
Source6:      aliases
Source7:      sysconfig.mailman
Source8:      permissions.mailman
Patch1:       mailman-wrapper.patch
%if %DISTRIBUTABLE
%else
Patch2:       mailman-SuSE.patch
%endif
Patch3:       mailman-2.1.1-python.dif
Patch5:       mailman-2.1.2-editarch.patch
Patch6:       mailman-2.1.2-misc-PACKAGES.diff
Patch7:       mailman-2.1.2-check_perms.diff
Patch15:      mailman-2.1.4-passwordretrieval.patch
Patch16:      mailman-2.1-CAN-2004-1177-noxml.patch
Patch17:      mailman-weak-password.diff
Patch18:      mailman-2.1.5-dirtraversal.patch
Patch20:      mailman-2.1-utf8-scrubber-workaround.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
%define       m_uid 72
%define       m_gid 67
%define       server_root_old /usr/local/httpd
%define       server_root_new /srv/www
%define       server_root %{server_root_new}
# ----------------------------------------------------------------------------

%description
This is the GNU Mailing List manager. Mailman provides an easy to
configure means of maintaining mailing lists including
web-administration. Mailman is written in Python.



Authors:
--------
    John Viega <mailman-users@python.org>

%prep
%setup
%patch1
%if %DISTRIBUTABLE
%else
%patch2
%endif
%patch3
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch15
%patch16 -p1
%patch17 -p1
%patch18
%patch20 -p1
cp -av %{S:1} .
# ----------------------------------------------------------------------------

%build
/usr/sbin/groupadd -g %{m_gid} -o -r mailman 2> /dev/null || :
/usr/sbin/useradd -r -o -g mailman -u %{m_uid} -s /bin/bash -c "GNU mailing list manager" -d /var/lib/mailman mailman 2> /dev/null || :
./configure --prefix=/usr/lib/mailman --sysconfdir=/etc \
	--localstatedir=/var/run --libexecdir=/usr/lib/mailman \
	--mandir=%{_mandir} --with-groupname=mailman --with-username=mailman \
	--with-var-prefix=/var/lib/mailman \
        --without-permcheck \
	--with-cgi-gid=nogroup --with-mail-gid=nobody # these two values will be faked anyway
make
# ----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{server_root}
install -d $RPM_BUILD_ROOT%{server_root}/icons
install -d $RPM_BUILD_ROOT/{usr/sbin,etc/{httpd,sysconfig,init.d,permissions.d},var/adm/fillup-templates,sbin/conf.d}/
(cd $RPM_BUILD_ROOT/etc/httpd/; tar xjvf %{S:2})
# note: PACKAGES= here is to avoid shipping same modules in mailman and for python
make DESTDIR=$RPM_BUILD_ROOT ICONDIR=%{server_root}/icons/ \
     PYTHONBASE="/usr/%_lib/python" install
# add user mailman in column 6 since we are going to use it as system crontab
awk '/^[0-9,\*]/ { print $1 " " $2 " " $3 " " $4 " " $5 " mailman " $6 " " $7 " " $8 } /^\#/ { print $0 }' \
	$RPM_BUILD_ROOT/usr/lib/mailman/cron/crontab.in \
	> $RPM_BUILD_ROOT/usr/lib/mailman/cron/crontab
nobodygid=`grep ^nobody /etc/group | cut -d: -f3`
nogroupgid=`grep ^nogroup /etc/group | cut -d: -f3`
echo $nobodygid > $RPM_BUILD_ROOT/etc/mailman.mail-gid
echo $nogroupgid > $RPM_BUILD_ROOT/etc/mailman.cgi-gid
install -m 644 %{S:3} $RPM_BUILD_ROOT/var/adm/fillup-templates/
install -m 755 %{S:4} $RPM_BUILD_ROOT/sbin/conf.d/SuSEconfig.mailman
ln -sf ../../etc/init.d/mailman $RPM_BUILD_ROOT/usr/sbin/rcmailman
install -m 755 %{S:5} $RPM_BUILD_ROOT/etc/init.d/mailman
install -m 664 %{S:6} $RPM_BUILD_ROOT/var/lib/mailman/data/aliases
# make sure there is a valid  group writable aliases.db
# if the aliases.db would be generated later on, list creation
# through the web interface would not work!
postalias $RPM_BUILD_ROOT/var/lib/mailman/data/aliases
chmod g+w $RPM_BUILD_ROOT/var/lib/mailman/data/aliases.db
install -m 644 %{S:7} $RPM_BUILD_ROOT/var/adm/fillup-templates/
install -m 644 %{S:8} $RPM_BUILD_ROOT/etc/permissions.d/mailman
# ----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT
# ----------------------------------------------------------------------------

%pre
/usr/sbin/groupadd -g %{m_gid} -o -r mailman 2> /dev/null || :
/usr/sbin/useradd -r -o -g mailman -u %{m_uid} -s /bin/bash -c "GNU mailing list manager" -d /var/lib/mailman mailman 2> /dev/null || :
# ----------------------------------------------------------------------------

%post
mkdir -p var/adm/notify/messages
cat << EOT > var/adm/notify/messages/mailman-notify
Please read /usr/share/doc/packages/mailman/README.SuSE to finish the setup.
Sincerely,
Your SuSE Team
EOT
%{fillup_and_insserv mailman}
%{fillup_only -an apache}
# Handle old installations
test -d var/spool/mailman && {
	echo -n "Moving /var/spool/mailman -> /var/lib/mailman... "
	(cd var/lib/mailman; cp -a var/spool/mailman/* .)
	rm -rf var/spool/mailman
	echo "Done."
}
echo "All done."
# use Mailman facilities for updating old data
usr/lib/mailman/bin/update
if test -z "$YAST_IS_RUNNING" ; then
	echo "Please remember to run 'SuSEconfig --module mailman' to configure mailman"
fi
# ----------------------------------------------------------------------------

%postun
%insserv_cleanup
# ----------------------------------------------------------------------------

%files
%defattr(-, root, root)
%doc ACKNOWLEDGMENTS BUGS FAQ INSTALL NEWS TODO UPGRADING
%doc README README.*
%dir %attr(2775, root, mailman) /usr/lib/mailman/
%attr(-, root, mailman) /usr/lib/mailman/[^M]*
%dir %attr(2775, root, mailman) /usr/lib/mailman/Mailman/
%attr(-, root, mailman) /usr/lib/mailman/Mailman/[^m]*
%config(noreplace) %attr(-, root, mailman) /usr/lib/mailman/Mailman/m*
%dir %attr(2775, root, mailman) /var/lib/mailman/
%attr(-, root, mailman) /var/lib/mailman/[^d]*
%dir %attr(2775, root, mailman) /var/lib/mailman/data/
%config(noreplace) %attr(-, root, mailman) /var/lib/mailman/data/*
%{server_root}/icons
/etc/httpd/mailman.conf
/etc/httpd/modules/mailman
%config(noreplace) /etc/mailman.*-gid
%config /etc/permissions.d/mailman
/var/adm/fillup-templates/*
/sbin/conf.d/*
/usr/sbin/*
/etc/init.d/*
# ----------------------------------------------------------------------------

%changelog -n mailman
* Wed Nov 23 2005 - rommel@suse.de
- replaced mailman-CAN-2004-1177.patch with patch
  mailman-2.1-CAN-2004-1177-noxml.patch that does not require python-xml
  [Bug #65100, CAN-2004-1177]
- removed python-xml from Requires:
- workarounded an utf8 decode bug in Python that was hit in the Scrubber module
  (mailman-2.1-utf8-scrubber-workaround.patch) [Bug #133692]
* Thu Feb 10 2005 - rommel@suse.de
- added mailman-2.1.5-dirtraversal.patch [bug #50563, CAN-2005-0202]
* Wed Jan 12 2005 - rommel@suse.de
- added mailman-weak-password.diff [bug #49468, CAN-2004-1144]
- added mailman-CAN-2004-1177.patch [bug #49468, CAN-2004-1177]
* Wed Nov 10 2004 - rommel@suse.de
- reworked start script (bug #42652)
* Mon May 24 2004 - rommel@suse.de
- security fix for remote password attack (bug #40868)
* Thu May 06 2004 - rommel@suse.de
- minor fix to check_perms [Bug #38867],
  file mailman-2.1.2-check_perms.diff
* Thu Aug 21 2003 - mmj@suse.de
- The fix below from mcihar@suse.cz was a little to rough, since
  mailman broke without it's own copy of email. So include email
  in the installation, but keep korean and japanese disabled.
* Thu Aug 14 2003 - rommel@suse.de
- added activation metadata in sysconfig templates
* Mon Aug 11 2003 - mcihar@suse.cz
- don't include in mailman package python modules we also ship (korean,
  japanese, email)
- notify user about running 'SuSEconfig --module mailman' if not in YaST
* Mon Aug 11 2003 - rommel@suse.de
- bug-fix update to version 2.1.2
- removed now-obsolete mailman-destdir.patch
- linkage of /etc/aliases.d/mailman to /var/lib/mailman/data/aliases
  has been dropped (unmaintainable)
- fixed mailmanctl to not freeze YaST2 [Bug #26990]
- fixed mail gid auto detection in SuSEconfig.mailman [Bug #27369]
- fixed Defaults.py to not reference build host [Bug #26988]
* Tue Aug 05 2003 - ro@suse.de
- don't leave buildroot traces in installed files
* Fri Jun 13 2003 - kukuk@suse.de
- Fix filelist
* Mon May 12 2003 - rommel@suse.de
- added DISTRIBUTABLE to be able to build the version used interally
* Mon Mar 17 2003 - kukuk@suse.de
- Don't enable mailman per default, does not work without correct
  configuration
* Mon Mar 10 2003 - rommel@suse.de
- test for presence of /usr/sbin/postalias (reported by Eberhard Moenkeberg)
- added RPM Summary [Bug #24810]
- added Description to rcmailman (shows in runlevel editor)
* Thu Mar 06 2003 - kukuk@suse.de
- Add openssl PreRequires [Bug #24785]
* Mon Feb 10 2003 - rommel@suse.de
- update to version 2.1.1 which obsoletes both mailman-xss.patch and
  mailman-syncmember.patch and fixes the rmlist bug
- added the config attribute to the alias file generated by mailman
  so it does not get lost on package removal
- added MAILMAN_LINK_ALIASES variable to the sysconfig stuff so one
  can create links in /etc/aliases.d that point to
  /var/lib/mailman/data/aliases* independent on the value of MAILMAN_MTA
* Sat Feb 01 2003 - rommel@suse.de
- fixed the start script to not freeze the runlevel editor on service start
- added metadata to sysconfig.apache-mailman
* Thu Jan 30 2003 - rommel@suse.de
- added missing metadata to sysconfig file
- added official patch against cross-site-scripting (XSS) vulnerability
* Wed Jan 29 2003 - rommel@suse.de
- update to version 2.1
- new start script
- new README.SuSE
- added SuSEconfig script that generates the wrapper gid files
  (/etc/mailman.*-gid) and provides an easy way to generate mm_cfg.py
  (Mailman's site configuration file)
* Tue Sep 17 2002 - ro@suse.de
- removed bogus self-provides
* Fri Aug 30 2002 - vinil@suse.cz
- enhanced PreRequires
- fixed default hostname in SuSEconfig (bug #17696)
- defaults set for Postfix MTA (Sendmail made optional)
* Mon Aug 12 2002 - vinil@suse.de
- new version: 2.0.13
* Fri Aug 02 2002 - ro@suse.de
- adapted server root
* Thu Jul 11 2002 - vinil@suse.cz
- new version: 2.0.12
- own user and group 'mailman'
- use /etc/aliases.d/mailman instead of /etc/aliases
- paragraph about creating ML added into README.SuSE
* Mon Jun 03 2002 - ro@suse.de
- fix build on lib64
- added openssl to neededforbuild
* Thu Jan 31 2002 - vinil@suse.cz
- README.SuSE typo fixed
* Thu Jan 24 2002 - vinil@suse.cz
- add rcscript, that moves crontab entry in /etc/cron.d/ and out
* Thu Jan 17 2002 - ro@suse.de
- adapted for /etc/sysconfig/apache
* Wed Jan 16 2002 - vinil@suse.cz
- installation is able to handle old /var/spool/mailman, now
- /var/lib/mailman/Mailman/mm_cfg.py* is %%config(noreplace)
* Tue Dec 11 2001 - vinil@suse.cz
- update to 2.0.8
- web frontend prepared for apache
- patch for configuratable cgi-gid and mail-gid
- taking care about /etc/aliases now
* Sun Aug 19 2001 - iboernig@suse.de
- update to new stable version 2.0.6
* Sun Aug 19 2001 - iboernig@suse.de
- fixed bug in specfile (Bug #9519) Apache GID is now nogroup again.
* Wed Apr 25 2001 - iboernig@suse.de
- changed mailgid to "daemon". It should work now with sendmail.
  Postfix users have to change default_privs
* Fri Mar 16 2001 - iboernig@suse.de
- updated to version 2.0.3, includes minor security fix
* Fri Jan 05 2001 - iboernig@suse.de
- bugfix: move crontab entry to /etc/cron.d/mailman
- notify user in %%post-section
- created README.SuSE
* Thu Dec 28 2000 - choeger@suse.de
- bugfix: --prefix=$RPM_BUILD_ROOT does NOT work, because then
  /var/tmp/mailman-* would be compiled into some .c files
  changed Makefiles to allow DESTDIR=/path
- create crontab entries in postinstall
- use gid of nogroup also for mail-wrapper
* Thu Nov 30 2000 - iboernig@suse.de
- changed default user.group to mdom.mdom
* Wed Nov 29 2000 - iboernig@suse.de
- initial version
